#!/bin/bash
set -eu

# Do not run on production servers
if [ "$(hostname)" == *prd* ]; then
   echo "Stop! This script must only be used on staging servers."
   exit 1
fi

# Name of production server to sync from must be present in host_vars
restore_server={{ sync_prd_database_server }}

# Get the necessary variables from the .env (important to strip quotes!)
export $(grep MYSQL_ROOT_PASSWORD /opt/project/linnaeus_ng/.env | tr -d '"')
export $(grep MYSQL_DATABASE /opt/project/linnaeus_ng/.env | tr -d '"')

# Delete previous dump files
rm /data/restore/data/backup/* -f

# Find latest backup file, restore from restic and unzip
echo "Retrieving latest backup dump..."
latest_dump=$(restic ls --host "${restore_server}" latest /data/backup --long | grep linnaeus | awk '{print $7}' | sort -n | tail -1)
restic restore --no-lock --host "${restore_server}" --include "${latest_dump}" --target /data/restore latest
gunzip /data/restore"${latest_dump}"

# Import dump if directory containing backup dump is not empty
if [ -z "$(ls -A '/data/restore/data/backup')" ]; then
    echo "No backup dump found."
else
    echo "Syncing database from ${latest_dump}..."
    docker compose \
        --project-directory /opt/project/linnaeus_ng \
        exec -T \
        database \
        /usr/bin/mysql --user=root --password="$MYSQL_ROOT_PASSWORD" "$MYSQL_DATABASE" < /data/restore"${latest_dump%.gz}"
    echo "Sync complete!"
fi